// AI Step&Repeat
//
//Vadim Kochenkov (c) 2022
//vadimych.ru
//v.0.1

#target illustrator

shiftX = 0;
shiftY = 0;

countX = 0;
countY = 0;

a = app.activeDocument;
s = app.selection;

var ratio = 0.35277777; //Блядский размер одного пункта (pt) по версии Indesign/Illustrator 2021


function createDialog()
{


dlg = new Window ('dialog', 'Ai: Simple Step & Repeat');

dlg.frameLocation = [100, 100];
dlg.size = [300, 250];
dlg.okbtn = dlg.add('button', [20, 170, 145, 190], 'Ок', 'spec');
dlg.cancelbtn = dlg.add('button',[155,170,280,190],'Cancel', 'spec');
//dlg.hor = dlg.add('edittext',[20,20,40,40]);
//dlg.ver = dlg.add('edittext',[50,20,70,40]);
dlg.horSlider = dlg.add('slider',[20,35,230,55]);
dlg.horSlider.minvalue = 1;
dlg.horSlider.maxvalue = 12;
dlg.horValue = dlg.add('edittext',[250,30,280,60],'1');
dlg.verSlider = dlg.add('slider',[20,85,230,105]);
dlg.verSlider.minvalue = 1;
dlg.verSlider.maxvalue = 12;
dlg.verValue = dlg.add('edittext',[250,80,280,110],'1');

dlg.verLabel = dlg.add('statictext',[20,65,170,85],'В высоту');
dlg.horLabel = dlg.add('statictext',[20,10,170,35],'В ширину');

dlg.horOffsetLabel = dlg.add('statictext',[20,130,110,150], 'Офсет ширина');
dlg.horOffset = dlg.add('edittext',[120,125,150,155],'0');

dlg.verOffsetLabel = dlg.add('statictext',[160,130,250,150], 'Офсет высота');
dlg.verOffset = dlg.add('edittext',[250,125,280,155],'0');
dlg.someText = dlg.add('statictext',[20,200,280,240],'vadimych.ru\n\n zzzz');//Чтоб от скромности не помереть :)
}//

function startSpec()
//Закрываем диалог и погнали
{
dlg.close();



countX = dlg.horValue.text;
countY = dlg.verValue.text;
shiftX = Math.round(dlg.horOffset.text)/ratio;
shiftY = Math.round(dlg.verOffset.text)/ratio;
mainWork();
}//

//Следующие 4 функции нужны для интерактивности в диалоговом окне, 
//чтоб цифровые вводы соответствовали слайдерам и наоборот
function horSliderChange()
{
	dlg.horSlider.value = dlg.horValue.text;
	wCount = dlg.horValue.text;	
}

function horChange()
{
	dlg.horValue.text = Math.round(dlg.horSlider.value);
	wCount = dlg.horValue.text;
}


function verSliderChange()
{
	dlg.verSlider.value = dlg.verValue.text;
	hCount = dlg.verValue.text;
}

function verChange()
{
	dlg.verValue.text = Math.round(dlg.verSlider.value);
	hCount = dlg.verValue.text;

}

function shiftChange(stepGroup)
//Сдвигаем точку начала степундрепита в место расположения исходной графики
{
	var bounds = stepGroup.geometricBounds;
	var boundsX = bounds[2]-bounds[0];
	var boundsY = bounds[1]-bounds[3];
	shiftX = shiftX+boundsX;
	shiftY = shiftY+boundsY;

}

function duplicate()
{


//alert (posX+'-'+posY);
SnRGroup = a.groupItems.add();
SnRGroup.name = 'SnR';

stepGroup = a.groupItems.add();//Тащим в группу все что собиремся степундрепитить :)
	for (i=0; i<s.length; i++)
			{	
			newItem = s[i].duplicate();
	//		newItem.moveToBeginning(stepGroup);
			newItem.moveToEnd(stepGroup);
			}
shiftChange(stepGroup);//Сдвигаем точку начала степундрепита в место расположения исходной графики
var posY = -shiftY;	
for (iY = 0; iY<countY; iY++)
{

var posX = -shiftX;
	for (iX = 0; iX<countX; iX++)
	
	{
		stepGroup1 = stepGroup.duplicate();
		stepGroup1.name = 'step-'+iX+'-'+iY;
		stepGroup1.translate(posX+shiftX,-(posY+shiftY));
		stepGroup1.move(SnRGroup, ElementPlacement.INSIDE);
		posX = posX+shiftX;
	}
posY = posY-shiftY;	
}
//Удаляем копируемую группу
stepGroup.remove();
//Удаляем исходное выделение
for (j=0; j<s.length;j++)
{
	s[j].remove();
}

}//

function mainWork()
{

if (s.length>0)
{
	duplicate();
}
}///


createDialog();
dlg.okbtn.addEventListener('click', startSpec);
dlg.horValue.addEventListener('change', horSliderChange);
dlg.horSlider.addEventListener('change', horChange);
dlg.verSlider.addEventListener('change', verChange);
dlg.verValue.addEventListener('change', verSliderChange);

dlg.center();
dlg.show();